<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2018 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

//defined('_VALID_CALL') or die('Direct Access is not allowed.');

include '../../../xtFramework/admin/main.php';

if (!$xtc_acl->isLoggedIn()) {
    die('login required');
}

if(_SYSTEM_SSL == true && checkHTTPS()==true){
	$link_base = _SYSTEM_BASE_HTTPS._SRV_WEB;
	if (_SYSTEM_SSL_PROXY=='true')
	{
		$ar = explode("/",_SYSTEM_BASE_HTTPS);
		unset($ar[count($ar)-1]);
		$l = implode('/',$ar);
		$link_base = $l._SRV_WEB;
	}
}else{
	$link_base = _SYSTEM_BASE_HTTP._SRV_WEB;
}

global $db, $language, $store_handler, $customers_status;

$customers_table = TABLE_CUSTOMERS;
$customers_address_table = TABLE_CUSTOMERS_ADDRESSES;
$custoemrs_status_table = TABLE_CUSTOMERS_STATUS;
$customers_status_description_table = TABLE_CUSTOMERS_STATUS_DESCRIPTION;
$customers_online_table = DB_PREFIX . "_customers_online_stats";

$rs = $db->Execute(
		"SELECT $customers_online_table.*, $customers_online_table.shop_id AS shopid, $customers_status_description_table.*, $customers_address_table.*, $customers_table.* FROM $customers_online_table " .
		"LEFT JOIN $customers_table ON ($customers_online_table.customers_id=$customers_table.customers_id) " . 
		"LEFT JOIN $customers_address_table ON ($customers_online_table.customers_id=$customers_address_table.customers_id AND $customers_address_table.address_class='default') " .
		"LEFT JOIN $custoemrs_status_table ON ($customers_table.customers_status=$custoemrs_status_table.customers_status_id) " . 
		"LEFT JOIN $customers_status_description_table ON ($custoemrs_status_table.customers_status_id=$customers_status_description_table.customers_status_id AND $customers_status_description_table.language_code='$langiage->code') " .
		"WHERE $customers_online_table.date_added >='" . date('Y-m-d h:i:s', strtotime('-1 hour')) . "'"
);
$customers = array();

if ($rs->RecordCount() > 0) {
	while (!$rs->EOF) {
		$fields = $rs->fields;
		$fields['ShopName'] = $store_handler->getStoreName($fields['shopid']);
		$fields['CustomerName'] = (empty($fields['customers_firstname']) ? 'Guest' : $fields['customers_firstname'] . ' ' . $fields['customers_lastname']);
		$fields['CustomerGroup'] = empty($fields['customers_status']) ? '' : $customers_status->getGroupName($fields['customers_status']);
		$customers[] = $fields;
		$rs->MoveNext();
	}
	$rs->Close();
}

?>
<html>
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="refresh" content="5; URL=<?php echo $link_base . 'customers_online_table.php';?>" />
	<style>
		.datagrid table { border-collapse: collapse; text-align: left; width: 100%; } .datagrid {font: normal 12px/150% Arial, Helvetica, sans-serif; background: #fff; overflow: hidden; border: 1px solid #D4D4D4; -webkit-border-radius: 3px; -moz-border-radius: 3px; border-radius: 3px; }.datagrid table td, .datagrid table th { padding: 3px 0px; }.datagrid table thead th {text-align:center;background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #E3DEE3), color-stop(1, #A6A4A5) );background:-moz-linear-gradient( center top, #E3DEE3 5%, #A6A4A5 100% );filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#E3DEE3', endColorstr='#A6A4A5');background-color:#E3DEE3; color:#FFFFFF; font-size: 15px; font-weight: bold; border-left: 1px solid #0070A8; } .datagrid table thead th:first-child { border: none; }.datagrid table tbody td { text-align:center;color: #00496B; border-left: 1px solid #E1EEF4;font-size: 12px;font-weight: normal; }.datagrid table tbody .alt td { background: #D3D2D4; color: #00496B; }.datagrid table tbody td:first-child { border-left: none; }.datagrid table tbody tr:last-child td { border-bottom: none; }.datagrid table tfoot td div { border-top: 1px solid #D4D4D4;background: #E1EEF4;} .datagrid table tfoot td { padding: 0; font-size: 12px } .datagrid table tfoot td div{ padding: 2px; }.datagrid table tfoot td ul { margin: 0; padding:0; list-style: none; text-align: right; }.datagrid table tfoot  li { display: inline; }.datagrid table tfoot li a { text-decoration: none; display: inline-block;  padding: 2px 8px; margin: 1px;color: #FFFFFF;border: 1px solid #006699;-webkit-border-radius: 3px; -moz-border-radius: 3px; border-radius: 3px; background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #006699), color-stop(1, #00557F) );background:-moz-linear-gradient( center top, #006699 5%, #00557F 100% );filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#006699', endColorstr='#00557F');background-color:#006699; }.datagrid table tfoot ul.active, .datagrid table tfoot ul a:hover { text-decoration: none;border-color: #006699; color: #FFFFFF; background: none; background-color:#BABABA;}div.dhtmlx_window_active, div.dhx_modal_cover_dv { position: fixed !important; }
	</style>
	</head>
	<body>
		<div class="datagrid">
			<table class="customers_table2">
				<thead>
					<tr>
						<th><?php echo TEXT_STORE; ?></th>
						<th><?php echo TEXT_NAME; ?></th>
						<th><?php echo TEXT_GROUP_ID; ?></th>
						<th><?php echo TEXT_EMAIL;?></th>
						<th><?php echo TEXT_PHONE;?></th>
						<th><?php echo TEXT_CUSTOMERS_COUNTRY_CODE;?></th>
					</tr>
				</thead>
				<tbody>
				<?php foreach ($customers as $cutomerData) : ?>
				<tr>
					<td><?php echo $cutomerData['ShopName']; ?></td>
					<td><?php echo $cutomerData['CustomerName']; ?></td>
					<td><?php echo $cutomerData['CustomerGroup']; ?></td>
					<td><?php echo $cutomerData['customers_email_address'];?></td>
					<td><?php echo $cutomerData['customers_phone'];?></td>
					<td><?php echo $cutomerData['customers_country_code'];?></td>
				</tr>
				<?php endforeach;?>
				</tbody>
			</table>
		</div>
	</body>
</html>
<?php 
?>