<?php

function getAddParcelPanel_shipcloud($orders_id)
{
    global $admin_order_edit;
    $order_data = $admin_order_edit->getOrderData();
    $delivery_addr = $order_data['order_data']['delivery'];

    $Panel = new PhpExt_Form_FormPanel('addParcelForm_shipcloud');
    $Panel->setId('addParcelForm_shipcloud'.$orders_id)
        ->setTitle(__define('TEXT_SHIPCLOUD_CREATE_LABEL'))
        ->setAutoWidth(true)
        ->setAutoHeight(true)
        ->setBodyStyle('padding: 10px;')
        ->setUrl("adminHandler.php?plugin=xt_ship_and_track&load_section=xt_ship_and_track&pg=saveOrder_shipcloud&orders_id=".$orders_id.'&sec='.$_SESSION['admin_user']['admin_key'])
    ;

    /**
     *   combo paket vorlagen
     */
    $eF = new ExtFunctions();
    $gridtype = $eF->getSetting('gridType');
    $eF->setSetting('gridType', 'EditGrid');
    $combo = $eF->_comboBox('shipcloud_package', __define('TEXT_XT_SHIPCLOUD_PACKAGE_TEMPLATE'), 'DropdownData.php?get=shipcloud_packages&plugin_code=xt_ship_and_track')
        ->setId('shipcloud_package'.$orders_id)
        ->setWidth(200)
        ->setLazyInit(false)
        ->attachListener('select',
            new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                 setShipcloudPackageTemplate(this.getValue(), $orders_id, shipcloud_packages);
            ")))
        ->attachListener('change',
            new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                //
            ")));
    $combo->getStore()->attachListener('load',
        new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                initShipcloudCombo('shipcloud_package', $orders_id );
            ")));
    $Panel->addItem($combo);

    /**
     *   länge breite ...
     */
    $Panel->addItem(PhpExt_Form_TextField::createTextField('package_length', __define('TEXT_SHIPCLOUD_PACKAGE_LENGTH'))->setAllowBlank(false));
    $Panel->addItem(PhpExt_Form_TextField::createTextField('package_width', __define('TEXT_SHIPCLOUD_PACKAGE_WIDTH'))->setAllowBlank(false));
    $Panel->addItem(PhpExt_Form_TextField::createTextField('package_height', __define('TEXT_SHIPCLOUD_PACKAGE_HEIGHT'))->setAllowBlank(false));
    $Panel->addItem(PhpExt_Form_TextField::createTextField('package_weight', __define('TEXT_SHIPCLOUD_PACKAGE_WEIGHT'))->setAllowBlank(false));

    /**
     *   combo versender
     */
    $eF = new ExtFunctions();
    $gridtype = $eF->getSetting('gridType');
    $eF->setSetting('gridType', 'EditGrid');
    $combo = $eF->_comboBox('shipcloud_carrier', __define('TEXT_XT_SHIPPER'), 'DropdownData.php?get=shipcloud_carriers&plugin_code=xt_ship_and_track')
        ->setId('shipcloud_carrier'.$orders_id)
        ->setWidth(200)->setAllowBlank(false)
        ->setLazyInit(false)
        ->attachListener('select',
            new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                 setShipcloudCarrierSelection(this.getValue(), $orders_id, shipcloud_carriers);
            ")));
    $combo->getStore()->attachListener('load',
        new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                initShipcloudCombo('shipcloud_carrier', $orders_id );
            ")));
    $Panel->addItem($combo);
    $eF->setSetting('gridType', $gridtype);

    /**
     *   combo versender service
     */
    $combo = hermes_ExtAdminHandler::_comboBox2('shipcloud_service', __define('TEXT_SHIPCLOUD_CARRIER_SERVICE'));
    $combo->setId('shipcloud_service'.$orders_id)
        ->setDisabled(true)->setAllowBlank(false)
        ->setValue( __define('TEXT_SHIPCLOUD_CHOOSE_CARRIER_FIRST'))
        ->setWidth(200);
    $Panel->addItem($combo);

    /**
     *   combo versender paket typ
     */
    $combo = hermes_ExtAdminHandler::_comboBox2('shipcloud_package_type', __define('TEXT_SHIPCLOUD_CARRIER_PACKAGE_TYPE'))
        ->setId('shipcloud_package_type'.$orders_id)
        ->setDisabled(true)->setAllowBlank(false)
        ->setValue( __define('TEXT_SHIPCLOUD_CHOOSE_CARRIER_FIRST'))
        ->setWidth(200);
    $Panel->addItem($combo);

    /**
     *   resize listener
     */
    $resize_listener = new PhpExt_Listener(PhpExt_Javascript::functionDef(null, "
                 syncRemoteWindowSize();
            "));

    /**
     *    additional services DHL
     */
    $field_set_add_service_dhl = new PhpExt_Form_FieldSet();
    $field_set_add_service_dhl ->setBorder(true)
        ->setId('group_add_service_dhl'.$orders_id)
        ->setBodyBorder(true)
        ->setCheckboxToggle(true)
        ->setCheckboxName('add_service_dhl')
        ->setTitle(TEXT_SHIPCLOUD_ADDITIONAL_SERVICES.' DHL')
        ->setAutoHeight(true)
        ->setDefaults(new PhpExt_Config_ConfigObject(array("margin-top"=>"100px")))
        ->setCollapsed(true)->attachListener('expand', $resize_listener)
        ->setCollapsed(true)->attachListener('collapse',$resize_listener);

    $tf = PhpExt_Form_TextField::createTextField('add_service_dhl_advance_notice_email', __define('TEXT_SHIPCLOUD_ADVANCE_NOTICE_EMAIL'));
    $tf->setValue("");
    $field_set_add_service_dhl->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('add_service_dhl_cash_on_delivery', __define('TEXT_SHIPCLOUD_CASH_ON_DELIVERY'));
    $tf->setValue("")->setId('add_service_dhl_cash_on_delivery'.$orders_id);
    $field_set_add_service_dhl->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('add_service_dhl_declared_value', __define('TEXT_SHIPCLOUD_DECLARED_VALUE_DHL'));
    $tf->setValue("")->setId('add_service_dhl_declared_value'.$orders_id);
    $field_set_add_service_dhl->addItem($tf);
    $Panel->addItem($field_set_add_service_dhl);

    /**
     *    additional services DPD
     */
    $field_set_add_service_dpd = new PhpExt_Form_FieldSet();
    $field_set_add_service_dpd ->setBorder(true)
        ->setId('group_add_service_dpd'.$orders_id)
        ->setBodyBorder(true)
        ->setCheckboxToggle(true)
        ->setCheckboxName('add_service_dpd')
        ->setTitle(TEXT_SHIPCLOUD_ADDITIONAL_SERVICES.' DPD')
        ->setAutoHeight(true)
        ->setDefaults(new PhpExt_Config_ConfigObject(array("margin-top"=>"100px")))
        ->setCollapsed(true)->attachListener('expand', $resize_listener)
        ->setCollapsed(true)->attachListener('collapse',$resize_listener);

    $tf = PhpExt_Form_TextField::createTextField('add_service_dpd_advance_notice_email', __define('TEXT_SHIPCLOUD_ADVANCE_NOTICE_EMAIL'));
    $tf->setValue("");
    $field_set_add_service_dpd->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('add_service_dpd_advance_notice_sms', __define('TEXT_SHIPCLOUD_ADVANCE_NOTICE_SMS'));
    $tf->setValue("+");
    $field_set_add_service_dpd->addItem($tf);
    $tf =  PhpExt_Form_TextField::createTextField('add_service_dpd_drop_authorization_msg', __define('TEXT_SHIPCLOUD_DROP_AUTHORIZATION_MSG'));
    $tf->setValue("");
    $field_set_add_service_dpd->addItem($tf);
    $tf = PhpExt_Form_Checkbox::createCheckbox('add_service_dpd_saturday_delivery', __define('TEXT_SHIPCLOUD_SATURDAY_DELIVERY'));
    $tf->setValue("");
    $field_set_add_service_dpd->addItem($tf);
    $Panel->addItem($field_set_add_service_dpd);

    /**
     *    Absender
     */
    $field_set_from = new PhpExt_Form_FieldSet();
    $field_set_from ->setBorder(true)
        ->setBodyBorder(true)
        ->setCheckboxToggle(true)
        ->setCheckboxName('override_default_from')
        ->setTitle(TEXT_SHIPCLOUD_OVERRIDE_FROM)
        ->setAutoHeight(true)
        ->setDefaults(new PhpExt_Config_ConfigObject(array("margin-top"=>"100px")))
        ->setCollapsed(true);

    $tf = PhpExt_Form_TextField::createTextField('from_first_name', __define('TEXT_SHIPCLOUD_FIRST_NAME'));
    $tf->setValue('');
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_last_name', __define('TEXT_SHIPCLOUD_LAST_NAME'));
    $tf->setValue('');
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_company', __define('TEXT_SHIPCLOUD_COMPANY'));
    $tf->setValue('');
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_street', __define('TEXT_SHIPCLOUD_STREET'));
    $tf->setValue("");
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_street_no', __define('TEXT_SHIPCLOUD_STREET_NO'));
    $tf->setValue("");
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_zip_code', __define('TEXT_SHIPCLOUD_ZIP_CODE'));
    $tf->setValue("");
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_city', __define('TEXT_SHIPCLOUD_CITY'));
    $tf->setValue("");
    $field_set_from->addItem($tf);
    $tf = PhpExt_Form_TextField::createTextField('from_country', __define('TEXT_SHIPCLOUD_COUNTRY'));
    $tf->setValue("");
    $field_set_from->addItem($tf)
        ->setCollapsed(true)->attachListener('expand', $resize_listener)
        ->setCollapsed(true)->attachListener('collapse',$resize_listener);
    $Panel->addItem($field_set_from);

    /**
     *   empfänger  hidden
     */
    $tf = PhpExt_Form_Hidden::createHidden('to_first_name', __define('TEXT_SHIPCLOUD_FIRST_NAME'));
    $tf->setValue($delivery_addr['firstname']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_last_name', __define('TEXT_SHIPCLOUD_LAST_NAME'));
    $tf->setValue($delivery_addr['lastname']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_company', __define('TEXT_SHIPCLOUD_COMPANY'));
    $tf->setValue($delivery_addr['company']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_care_of', __define('TEXT_SHIPCLOUD_CARE_OF'));
    $tf->setValue('');
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_street', __define('TEXT_SHIPCLOUD_STREET'));
    $tf->setValue($delivery_addr['street_address']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_street_no', __define('TEXT_SHIPCLOUD_STREET_NO'));
    $tf->setValue('');
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_zip_code', __define('TEXT_SHIPCLOUD_ZIP_CODE'));
    $tf->setValue($delivery_addr['postcode']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_city', __define('TEXT_SHIPCLOUD_CITY'));
    $tf->setValue($delivery_addr['city']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_state', __define('TEXT_SHIPCLOUD_STATE'));
    $tf->setValue($delivery_addr['federal_state_code']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_country', __define('TEXT_SHIPCLOUD_COUNTRY'));
    $tf->setValue($delivery_addr['country_code']);
    $Panel->addItem($tf);
    $tf = PhpExt_Form_Hidden::createHidden('to_phone', __define('TEXT_SHIPCLOUD_PHONE'));
    $tf->setValue($delivery_addr['mobile_phone'] ? $delivery_addr['mobile_phone'] : $delivery_addr['phone']);
    $Panel->addItem($tf);


    /**
     *    hidden fields
     */
    $Panel->addItem(PhpExt_Form_Hidden::createHidden('quote', 0));
    $Panel->addItem(PhpExt_Form_Hidden::createHidden('prepare_label', 0));
    $Panel->addItem(PhpExt_Form_Hidden::createHidden('shop_id', $admin_order_edit->order_data['order_data']['shop_id']));
    $hidden = PhpExt_Form_Hidden::createHidden('order_total_price', number_Format($admin_order_edit->order_data['order_total']['total']['plain'], 2, ',', ''));
    $hidden->setId('order_total_price'.$orders_id);
    $Panel->addItem($hidden);

    /**
     *    Buttons
     */
    $quoteBtn = PhpExt_Button::createTextButton(__define("BUTTON_SHIPCLOUD_QUOTE"),
        new PhpExt_Handler(PhpExt_Javascript::stm("
            shipcloud_sendForm(".$orders_id.", 'quote');
            "))
    );
    $quoteBtn->setType(PhpExt_Button::BUTTON_TYPE_BUTTON);
    $quoteBtn->setId("BUTTON_SHIPCLOUD_QUOTE".$orders_id);
    $Panel->addButton($quoteBtn);

    $aveBtn = PhpExt_Button::createTextButton(__define("BUTTON_SHIPCLOUD_SAVE"),
        new PhpExt_Handler(PhpExt_Javascript::stm("
            shipcloud_sendForm(".$orders_id.", 'prepare_label');
            "))
    );
    $aveBtn->setType(PhpExt_Button::BUTTON_TYPE_SUBMIT);
    $aveBtn->setId("BUTTON_SHIPCLOUD_SAVE".$orders_id);
    $Panel->addButton($aveBtn);

    $submitBtn = PhpExt_Button::createTextButton(__define("TEXT_SHIPCLOUD_CREATE_LABEL"),
        new PhpExt_Handler(PhpExt_Javascript::stm("
            shipcloud_sendForm(".$orders_id.");
            "))
    );
    $submitBtn->setType(PhpExt_Button::BUTTON_TYPE_SUBMIT);
    $submitBtn->setId("TEXT_SHIPCLOUD_CREATE_LABEL".$orders_id);
    $Panel->addButton($submitBtn);

    return $Panel;
}