<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2018 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class multistore
{

    public $shop_id = 1;

    protected $_table = TABLE_MANDANT_CONFIG;
    protected $_table_lang = null;
    protected $_table_seo = null;
    protected $_master_key = 'shop_id';

    function __construct($admin = false)
    {
        $this->defaultStore = '1';

        $this->active = true;
        if ($admin) {
            $this->shops = $this->Stores();
        }
    }
    
    /**
     * read license file and return requested parameters
     * @param unknown $params
     */
    public function getLicenseFileInfo($params=array()) {
    	
    	if (count($params)==0) return;
    	$return=array();
    	$_lic = _SRV_WEBROOT . 'lic/license.txt';
    	if (!file_exists($_lic))
    		die('- xt:Commerce License File missing -');


    	$_file_content = file($_lic);
    	foreach ($_file_content as $bline_num => $bline) {
    		if (strpos($bline, ':') !== FALSE) {

    			$val_line = substr($bline,0,strpos($bline, ':'));

    			if (in_array($val_line,$params)) {
    				$return[$val_line]=trim(substr($bline,strpos($bline, ':')+1));
    			}
    		}
    		
    	}
    	return $return;
    }

    function checkAdminSSL()
    {
        global $db;

        $admin_ssl = false;
        $this->determineStoreId();
        $query = "SELECT admin_ssl FROM " . TABLE_MANDANT_CONFIG . " where shop_id=?";
        $record = $db->Execute($query, array($this->shop_id));
        if ($record->RecordCount() == 1 && $record->fields['admin_ssl'] == 1) {
            $admin_ssl = true;
        }

        define('_SYSTEM_ADMIN_SSL', $admin_ssl);
    }

    function redirectAdminSSL()
    {
        global $filter;

        $domain = $filter->_filter($_SERVER['SERVER_NAME']);
        if (_SYSTEM_ADMIN_SSL)
        {
            $reload = false;
            $replace = "https://";
            if ((str_replace($replace, "", _SYSTEM_BASE_HTTPS) != $domain))
            {
                // ok, jetzt noch eine versuch für 1&1
                if ((str_replace("https://www.", "", _SYSTEM_BASE_HTTPS) != $domain))
                {
                    $reload = true;
                }
            }

            $domain = _SYSTEM_BASE_HTTPS;
            $domain = str_replace($replace, "", $domain);

            if (checkHTTPS() == false)
                header('location: https://' . $domain . $_SERVER['REQUEST_URI']);
            else if ($reload)
                header('location: https://' . $domain . $_SERVER['REQUEST_URI']);
        } else {
            if (checkHTTPS() == true)
                header('location: http://' . $domain . $_SERVER[REQUEST_URI]);
        }
    }

    function determineStoreId()
    {
        global $db, $filter;

        if (!$this->active)
            return $this->defaultStore;
        $domain = $filter->_filter($_SERVER['SERVER_NAME']);
        $this->domain = $domain;

        $no_ssl_domain = false;
        /*
        if ((_SYSTEM_SSL_PROXY == 'true') && isset($_SERVER['HTTPS'])) {
            $exp = explode("/", $_SERVER['REQUEST_URI']);
            //echo $exp[1];
            $domain = $exp[1];
            $no_ssl_domain = true;
        }
        */

        // license restrictions
        if (/*multi_store_check_max_stores()*/ true) {
            $this->shop_id = '1';

            $this->setStatusAndDieIfNotActive($this->shop_id);

            return;
        }

        if (isset($_SERVER['HTTPS'])) {
            $domain2 = (strpos($domain, "www.") === false) ? ('www.' . $domain) : (str_replace("www.", "", $domain));
            if ($no_ssl_domain == 'true') {
                $query = "SELECT shop_id,shop_status FROM " . TABLE_MANDANT_CONFIG . " where shop_domain = ? or shop_domain = ?";
            } else {
                $query = "SELECT shop_id,shop_status FROM " . TABLE_MANDANT_CONFIG . " where shop_ssl_domain = ? or shop_ssl_domain = ?";
            }
        } else {
            $domain2 = (strpos($domain, "www.") === false) ? ('www.' . $domain) : (str_replace("www.", "", $domain));
            $query = "SELECT * FROM " . TABLE_MANDANT_CONFIG . " where shop_domain = ? or shop_domain = ?";
        }
        $record = $db->Execute($query, array($domain, $domain2));

        if ($record->RecordCount() == 0) { // no record found, set store ID to default
            $this->shop_id = $this->defaultStore;
        } elseif ($record->RecordCount() > 500) { // found more, check for virtual folder // tmp deaktivated maybe in 4.0.13
            $this->shop_id = $this->defaultStore;
        } elseif ($record->RecordCount() == 1) {  // found one, set store ID to found
            $this->shop_id = $record->fields['shop_id'];
        } else {
            $this->shop_id = $this->defaultStore;
        }

        $this->setStatusAndDieIfNotActive($this->shop_id);
    }

    function setStatusAndDieIfNotActive($store_id)
    {
        global $db, $debug_ip;

        $query = "SELECT shop_status FROM " . TABLE_MANDANT_CONFIG . " where shop_id = ? ";
        $shop_status = $db->GetOne($query, array($store_id));

        if($shop_status == 0)
        {
            $this->shop_active = false;

            if (empty($debug_ip) && USER_POSITION == 'store' && !defined('XT_WIZARD_STARTED'))
    {
                    $error_file = _SRV_WEBROOT . 'xtCore/ShopNotActive.html';

                    if (file_exists($error_file)) {
                        $fp = fopen($error_file, "rb");
                        $buffer = fread($fp, filesize($error_file));
                        fclose($fp);
                        die ($buffer);
                    }
            }
        }
    }

    /**
     * load and define main store configuration from config_x
     * @param string $id
     */
    function loadStoreConfigMainData($id = '')
    {
        global $db, $xtPlugin, $language;
        ($plugin_code = $xtPlugin->PluginCode(__CLASS__ . ':loadConfig_top')) ? eval($plugin_code) : false;

        if ($id != '')
        {
            $this->shop_id = $id;
        }
        else
        {
            if (!isset ($this->shop_id))
            {
                $this->shop_id = $this->defaultStore;
            }
        }

        _buildDefine($db, TABLE_CONFIGURATION_MULTI . $this->shop_id);
    }
    
    /**
     * load main store configuration
     * @param string $id
     * @return multitype:NULL
     */
    function getStoreConfig($id='') {
    	global $db, $xtPlugin, $language;
    	
    	($plugin_code = $xtPlugin->PluginCode(__CLASS__ . ':getStoreConfig')) ? eval($plugin_code) : false;
    	
    	if ($id != '')
    	{
    		$this->shop_id = $id;
    	}
    	else
    	{
    		if (!isset ($this->shop_id))
    		{
    			$this->shop_id = $this->defaultStore;
    		}
    	}
    	
    	$record = $db->Execute("SELECT config_key, config_value FROM " .TABLE_CONFIGURATION_MULTI . $this->shop_id);
    	$config = array();
    	while (!$record->EOF) {   		
    		$config[strtoupper($record->fields['config_key'])] = $record->fields['config_value'];
    		$record->MoveNext();
    	}
    	$record->Close();
    	return $config;
    }

    /**
     * load and define full store configuration (config, payment, language)
     * @param string $id
     */
    function loadConfig($id = '')
    {
        global $db, $xtPlugin, $language;
        ($plugin_code = $xtPlugin->PluginCode(__CLASS__ . ':loadConfig_top')) ? eval($plugin_code) : false;

        if ($id != '') {
            $this->shop_id = $id;
        } else {
            if (!isset ($this->shop_id))
                $this->shop_id = $this->defaultStore;
        }

        _buildDefine($db, TABLE_CONFIGURATION_LANG_MULTI, 'config_key', 'language_value', 'store_id=' . $this->shop_id . ' AND language_code='.$db->Quote($language->content_language));

        _buildDefine($db, TABLE_CONFIGURATION_PAYMENT, 'config_key', 'config_value', 'shop_id=' . $this->shop_id);

        _buildDefine($db, TABLE_PLUGIN_CONFIGURATION, 'config_key', 'config_value', 'shop_id=' . $this->shop_id);

        $record = $db->Execute("SELECT * FROM " . TABLE_MANDANT_CONFIG . " where shop_id = '" . $this->shop_id . "' ");

        $virtual_folder = (isset($record->fields['virtual_folder']) ? $record->fields['virtual_folder'] : '');
        define('_SYSTEM_BASE_VIRTUAL_FOLDER', $virtual_folder);
        define('_SYSTEM_BASE_HTTP', $record->fields['shop_http']);
        define('_SYSTEM_BASE_HTTPS', $record->fields['shop_https']);

        if ($record->fields['shop_ssl'] == 'no_ssl') {
            define('_SYSTEM_SSL', false);
            define('_SYSTEM_FULL_SSL', false);
            $ssl = false;
        } else {
            define('_SYSTEM_SSL', true);
            $S_SYSTEM_FULL_SSL = false;
            if ($record->fields['shop_ssl'] == 'full_ssl')
                $S_SYSTEM_FULL_SSL = true;

            define('_SYSTEM_FULL_SSL', $S_SYSTEM_FULL_SSL);
            $ssl = false;
            if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ) {
                $ssl = true;
            }

            // check for proxy
            if (isset($_SERVER['HTTP_X_FORWARDED_HOST'])) {

                preg_match('@^(?:https://)?([^/]+)@i', $record->fields['shop_https'], $treffer);
                $host = $treffer[1];
                if ($_SERVER['HTTP_X_FORWARDED_HOST'] == $host) $ssl = true;
            }
        }

        if (!$ssl) {
            define('_SYSTEM_CONNECTION', 'NORMAL');
            define('_SYSTEM_BASE_URL', _SYSTEM_BASE_HTTP);
        } else {
            define('_SYSTEM_CONNECTION', 'SSL');
            define('_SYSTEM_BASE_URL', _SYSTEM_BASE_HTTPS);
        }
    }

    function getStores()
    {
        global $db, $xtPlugin;
        $where = '';
        ($plugin_code = $xtPlugin->PluginCode(__CLASS__ . ':getStores_top')) ? eval($plugin_code) : false;
        static $cache =  array();

        $hash = $where; //crc32($where);
        if(!array_key_exists($hash, $cache))
        {
            $rs = $db->CacheExecute("SELECT * FROM " . TABLE_MANDANT_CONFIG . " " . $where . " ORDER BY shop_id ASC");
            $data = array();
            while (!$rs->EOF)
            {
                $data[] = array(
                    'id' => $rs->fields['shop_id'],
                    'text' => $rs->fields['shop_domain'],
                    'status' => $rs->fields['shop_status']
                );
                $rs->MoveNext();
            }
            $rs->Close();

            $cache[$hash] = $data;
        }
        $data = $cache[$hash]; // to be compatible for old code using the next hook

        ($plugin_code = $xtPlugin->PluginCode(__CLASS__ . ':getStores_bottom')) ? eval($plugin_code) : false;

        return $data;
    }

    /**
     * define store permission names for TEXT_SHOP_n
     *
     */
    function _defineStorePermissionNames()
    {
        global $db;
        $rs = $db->Execute("SELECT shop_domain,shop_id FROM " . TABLE_MANDANT_CONFIG);
        if ($rs->RecordCount() > 0) {
            while (!$rs->EOF) {
                define('TEXT_SHOP_' . $rs->fields['shop_id'], $rs->fields['shop_domain']);
                $rs->MoveNext();
            }
            $rs->Close();
        }
    }

    function getStoreName($id)
    {
        global $db;
        $record = $db->Execute("SELECT shop_domain FROM " . TABLE_MANDANT_CONFIG . " where shop_id = ?", array((int)$id));
        if ($record->RecordCount() > 0) {
            return $record->fields['shop_domain'];
        }
    }

    function saveStore($data)
    {
        global $db, $filter, $currency, $language;

        $shop_id = (int)$data['edit_id'];

        $data_array = array();
        $data_array['shop_http'] = $filter->_filter($data['shop_http']);
        $data_array['shop_domain'] = $filter->_filter($data['shop_domain']);
        $data_array['shop_ssl_domain'] = $filter->_filter($data['shop_ssl_domain']);
        $data_array['shop_https'] = $filter->_filter($data['shop_https']);
        $data_array['shop_ssl'] = $filter->_filter($data['shop_https_status']);

        if ($data_array['shop_ssl'] != 1)
            $data_array['shop_ssl'] = 0;

        $db->AutoExecute(TABLE_MANDANT_CONFIG, $data_array, 'UPDATE', 'shop_id=' . (int)$shop_id);

        // language & Currency
        $db->Execute("UPDATE " . TABLE_LANGUAGES . " SET shop_" . $shop_id . "=0");
        foreach ($language->_getLanguageList('admin') as $key => $val) {
            if ($data['lang_' . $val['id']] == 'on')
                $db->Execute("UPDATE " . TABLE_LANGUAGES . " SET shop_" . $shop_id . "=1 WHERE code=?", array($val['id']));
        }

        $db->Execute("UPDATE " . TABLE_CURRENCIES . " SET shop_" . (int)$shop_id . "=0");
        foreach ($currency->_getCurrencyList('admin') as $key => $val) {
            if ($data['currency_' . $val['id']] == 'on')
                $db->Execute("UPDATE " . TABLE_CURRENCIES . " SET shop_" . (int)$shop_id . "=1 WHERE code=?", array($val['id']));
        }

        $db->Execute(
            "UPDATE " . TABLE_CONFIGURATION_MULTI . $shop_id . " SET config_value=? where config_key='_STORE_CURRENCY'",
            array($data['default_currency'])
        );
        $db->Execute(
            "UPDATE " . TABLE_CONFIGURATION_MULTI . $shop_id . " SET config_value=? where config_key='_STORE_LANGUAGE'",
            array($data['default_language'])
        );

        $rs = $db->Execute("select * from " . TABLE_CONFIGURATION_MULTI . $shop_id);
        while (!$rs->EOF) {
            if ($rs->fields['group_id'] != 6) {
                $db->Execute(
                    "UPDATE " . TABLE_CONFIGURATION_MULTI . $shop_id . " SET config_value=? where config_key=?",
                    array($data[$rs->fields['config_key']], $rs->fields['config_key'])
                );
            }
            $rs->MoveNext();
        }
        $rs->Close();
    }


    function inStallStore($data)
    {
        global $db, $filter;

        $insert_array = array();
        $insert_array['shop_http'] = $filter->_quote($data['shop_http']);
        $insert_array['shop_domain'] = $filter->_quote($data['shop_domain']);
        $insert_array['shop_ssl_domain'] = $filter->_quote($data['shop_ssl_domain']);
        $insert_array['shop_https'] = $filter->_quote($data['shop_https']);
        $insert_array['shop_ssl'] = (int)$data['shop_ssl'];
        $insert_array['shop_status'] = '0';
        $db->AutoExecute(TABLE_MANDANT_CONFIG, $insert_array);
        $shop_id = $db->Insert_ID();
        // replicate shopsettings
        $db->Execute("DROP TABLE IF EXISTS " . TABLE_CONFIGURATION_MULTI . $shop_id);
        $db->Execute("CREATE TABLE " . TABLE_CONFIGURATION_MULTI . $shop_id . " LIKE " . TABLE_CONFIGURATION_MULTI . "1");
        $db->Execute("INSERT INTO " . TABLE_CONFIGURATION_MULTI . $shop_id . " select * FROM " . TABLE_CONFIGURATION_MULTI . "1");
        // extend languages
        $db->Execute("ALTER TABLE " . TABLE_LANGUAGES . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");
        $db->Execute("ALTER TABLE " . TABLE_CURRENCIES . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");
        $db->Execute("ALTER TABLE " . TABLE_CUSTOMERS_STATUS . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");
        $db->Execute("ALTER TABLE " . TABLE_MAIL_TEMPLATES_ATTACHMENT . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");
        $db->Execute("ALTER TABLE " . TABLE_CONTENT . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");
        $db->Execute("ALTER TABLE " . TABLE_MAIL_TEMPLATES . " ADD shop_" . $shop_id . " INT( 11 ) NOT NULL DEFAULT '0'");

        // language & Currency
        $db->Execute("UPDATE " . TABLE_CURRENCIES . " SET shop_" . $shop_id . "=0");
        if (is_array($data['currencies'])) {
            foreach ($data['currencies'] as $key => $var) {
                $db->Execute("UPDATE " . TABLE_CURRENCIES . " SET shop_" . $shop_id . "=1 WHERE code=?", array($var));
            }
        }
        $db->Execute("UPDATE " . TABLE_LANGUAGES . " SET shop_" . $shop_id . "=0");
        if (is_array($data['languages'])) {
            foreach ($data['languages'] as $key => $var) {
                $db->Execute("UPDATE " . TABLE_LANGUAGES . " SET shop_" . $shop_id . "=1 WHERE languages_id=?", array($var));
            }
        }
    }

    function deleteStore($id)
    {
        global $db;
        $shop_id = (int)$id;
        if ($id != '1') {
            // drop config DB
            $db->Execute("DROP TABLE IF EXISTS " . TABLE_CONFIGURATION_MULTI . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_LANGUAGES . " DROP shop_" . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_CURRENCIES . " DROP shop_" . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_CUSTOMERS_STATUS . " DROP shop_" . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_MAIL_TEMPLATES_ATTACHMENT . " DROP shop_" . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_CONTENT . " DROP shop_" . $shop_id);
            $db->Execute("ALTER TABLE " . TABLE_MAIL_TEMPLATES . " DROP shop_" . $shop_id);

            // remove entry
            $db->Execute("DELETE FROM " . TABLE_MANDANT_CONFIG . " WHERE shop_id=?", array($shop_id));
            // remove payment config
            $db->Execute("DELETE FROM " . TABLE_CONFIGURATION_PAYMENT . " WHERE shop_id=?", array($shop_id));
        }
    }

    function getStoresData($parent = 0)
    {

        if ($parent == 'stores') {
            $store_id = 0;
        }
        if (strstr($parent, 'stores_')) {
            $tmp = explode('_', $parent);
            $store_id = (int)$tmp[1];
        }


        $stores = $this->getStores();
        $erg = array();
        if (is_array($stores)) {
            foreach ($stores as $key => $store) {

                $leaf = '';
                $type = 'G';
                $icon = 'images/icons/server.png';
                if ($store['status'] == 0) $icon = 'images/icons/server_delete.png';

                $url_d = 'adminHandler.php?load_section=multistore&edit_id=' . $store['id'];
                $arrTMP = Array('text' => $store['text'].'  id:'.$store['id']
                , 'url_i' => ''
                , 'url_d' => $url_d
                , 'tabtext' => $store['text']
                , 'id' => 'store_' . $store['id']
                , 'type' => 'G'
                , 'leaf' => ''
                , 'icon' => $icon
                );
                $erg[] = $arrTMP;
            }

        }
        return $erg;
    }

    function copyPermissions($table, $target_store, $source_store = '1')
    {
        global $db;

        $result = $this->getOldestShop();
        if ($result != '') {
            $source_store = $result['shop_id'];
        }
        $record = $db->Execute("SELECT * FROM " . $table . " where pgroup = 'shop_" . $source_store . "'");
        while (!$record->EOF) {

            $record->fields['pgroup'] = 'shop_' . $target_store;
            $db->AutoExecute($table, $record->fields);

            $record->MoveNext();
        }
        $record->Close();

    }

    /* copySeoValuesByShop
     *
     * copy content of a given table
     *
     * @param (string) ($table) - the resource table
     * @param (string) ($target_store) - data will be copied for this store id
     * @param (string) ($source_store) - store details to be copied
     * @param (string) ($store_field) - filed for store ID in the given table
     * @param (string) ($where) - sql added to query
     */
    function copyTableValuesByShop($table, $target_store, $source_store = '', $store_field = 'shop_id', $where = '', $primary_key = 'id')
    {
        global $db;
        if ($source_store == '') {
            $result = $this->getOldestShop();
            if ($result != '') {
                $source_store = $result['shop_id'];
            }
        }

        $record = $db->Execute("SELECT * FROM " . $table . " where " . $store_field . " = ? " . $where, array($source_store));
        while (!$record->EOF) {

            $record->fields[$store_field] = $target_store;
            unset ($record->fields[$primary_key]);
            $db->AutoExecute($table, $record->fields);

            $record->MoveNext();
        }
        $record->Close();

    }

    /* copySeoValuesByShop
     *
     * copy content of seo_urls table
     *
     * @param (string) ($table) - the resource table
     * @param (string) ($target_store) - data will be copied for this store id
     * @param (string) ($source_store) - store details to be copied
     */
    function copySeoValuesByShop($table, $target_store, $source_store = '')
    {
        global $db;
        if ($source_store == '') {
            $result = $this->getOldestShop();
            if ($result != '') {
                $source_store = $result['shop_id'];
            }
        }

        $record = $db->Execute("SELECT * FROM " . $table . " where store_id = ? ", array($source_store));
        while (!$record->EOF) {

            $record->fields['store_id'] = $target_store;
            unset ($record->fields['id']);
            $record->fields['url_text'] = $record->fields['url_text'];
            $record->fields['url_md5'] = md5($record->fields['url_text']);
            $db->AutoExecute($table, $record->fields);

            $record->MoveNext();
        }
        $record->Close();

    }

    function getOldestShop()
    {
        global $db;
        $result = '';
        $record = $db->Execute("SELECT shop_id FROM " . TABLE_MANDANT_CONFIG . " WHERE shop_status=1 ORDER BY shop_id LIMIT 0,1");
        if ($record->RecordCount() > 0) {
            $result = $record->fields;
        }
        $record->Close();

        return $result;
    }

    function deletePermissions($table, $id)
    {
        global $db;

        $db->Execute("DELETE FROM " . $table . " WHERE pgroup = 'shop_" . (int)$id . "'");

    }

    function deleteCustomer($id)
    {
        global $db;

        $record = $db->Execute("SELECT customers_id FROM " . TABLE_CUSTOMERS . " where shop_id = ?", array($id));
        while (!$record->EOF) {
            $customer = new customer($record->fields['customers_id']);
            $customer->_unset($record->fields['customers_id']);
            $record->MoveNext();
        }
        $record->Close();

    }

    function deleteOrder($id)
    {
        global $db;

        $record = $db->Execute("SELECT customers_id,orders_id FROM " . TABLE_ORDERS . " where shop_id = ?", array($id));
        while (!$record->EOF) {

            $order = new order($record->fields['orders_id'], $record->fields['customers_id']);
            $order->_deleteOrder($record->fields['orders_id']);
            $record->MoveNext();
        }
        $record->Close();
    }

    function _get($ID = 0)
    {
        global $db;

        $obj = new stdClass;

        if ($ID === 'new') {
            $new_shop = true;
            $obj = $this->_set(array(), 'new');
            $ID = $obj->new_id;
        } else {
            $ID = str_replace('store_', '', $ID);
            $ID = (int)$ID;
        }

        $table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key);

        if ($this->url_data['get_data']) {
            $data = $table_data->getData();
        } elseif ($ID) {
            $data = $table_data->getData($ID);
        } else {
            $data = $table_data->getHeader();
        }

        if ($table_data->_total_count != 0 || !$table_data->_total_count)
            $count_data = $table_data->_total_count;
        else
            $count_data = count($data);
        if ($new_shop) $data[0]['shop_ssl'] = 'no_ssl';

        $obj->totalCount = $count_data;
        $obj->data = $data;

        return $obj;
    }

    function _set($data, $set_type = 'edit')
    {
        global $db, $xtPlugin, $language;

        $obj = new stdClass;

        foreach ($data as $key => $val) {
            if ($val == 'on')
                $val = 1;
            $data[$key] = $val;
        }
        
        // check ssl and non ssl domain TODO
        /*
        $domain = $data['shop_domain'];
        $ssl_domain = $data['shop_ssl_domain'];
        $obj->error_message = TEXT_ERROR_NO_PROXY_SUPPORTED;
        return $obj;
        */
        
        if ($set_type != 'new') {


            // only perform this code if
            $data['shop_id'] = (int)$data['shop_id'];

            if ($data['shop_id'] > 0) {


            	
                $o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
                $objS = $o->saveDataSet();


                foreach ($language->_getLanguageList() as $key => $val) {
                    $db->Execute(
                        "UPDATE " . TABLE_LANGUAGE_CONTENT . " SET language_value =?
                            WHERE language_code = ? and  language_key= ? ",
                        array($data['shop_domain'], $val['code'], 'TEXT_CAT_STORE' . $data['shop_id'])
                        );
                }

            
            } else {
                // we do have a new shop here
                // check if max amount allready in db
                $rs = $db->Execute("SELECT * FROM " . $this->_table);
                $rc_count = $rs->RecordCount();
                if (/*multi_store_check_max_stores($rc_count)*/ true) {

                    // save entry
                    $o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
                    $objS = $o->saveDataSet();

                    $shop_id = $objS->new_id;

                    // create tables
                    $db->Execute("DROP TABLE IF EXISTS " . TABLE_CONFIGURATION_MULTI . $objS->new_id);

                    $db->Execute("CREATE TABLE " . TABLE_CONFIGURATION_MULTI . $objS->new_id . " LIKE " . TABLE_CONFIGURATION_MULTI . "1");
                    $db->Execute("INSERT INTO " . TABLE_CONFIGURATION_MULTI . $objS->new_id . " select * FROM " . TABLE_CONFIGURATION_MULTI . "1");

                    $this->copyPermissions(TABLE_CONTENT_PERMISSION, $objS->new_id);
                    $this->copyPermissions(TABLE_PRODUCTS_PERMISSION, $objS->new_id);
                    $this->copyPermissions(TABLE_CATEGORIES_PERMISSION, $objS->new_id);
                    $this->copyTableValuesByShop(TABLE_CONFIGURATION_PAYMENT, $objS->new_id);
                    $this->copyTableValuesByShop(TABLE_PLUGIN_CONFIGURATION, $objS->new_id);
                    if (StoreIdExists(TABLE_PRODUCTS_DESCRIPTION, 'products_store_id'))
                        $this->copyTableValuesByShop(TABLE_PRODUCTS_DESCRIPTION, $shop_id, '', 'products_store_id');
                    if (StoreIdExists(TABLE_CONTENT_ELEMENTS, 'content_store_id'))
                        $this->copyTableValuesByShop(TABLE_CONTENT_ELEMENTS, $shop_id, '', 'content_store_id');
                    if (StoreIdExists(TABLE_MANUFACTURERS_DESCRIPTION, 'manufacturers_store_id'))
                        $this->copyTableValuesByShop(TABLE_MANUFACTURERS_DESCRIPTION, $shop_id, '', 'manufacturers_store_id');
                    if (StoreIdExists(TABLE_CATEGORIES_DESCRIPTION, 'categories_store_id'))
                        $this->copyTableValuesByShop(TABLE_CATEGORIES_DESCRIPTION, $shop_id, '', 'categories_store_id');
                    if (StoreIdExists(TABLE_PRODUCTS_TO_CATEGORIES, 'store_id'))
                        $this->copyTableValuesByShop(TABLE_PRODUCTS_TO_CATEGORIES, $shop_id, '', 'store_id');


                    if (StoreIdExists(TABLE_SEO_URL, 'store_id'))
                        $this->copySeoValuesByShop(TABLE_SEO_URL, $objS->new_id);

                    $db->Execute("INSERT INTO " . TABLE_ADMIN_NAVIGATION . " (text,  sortorder, parent, type, navtype)
								VALUES ('cat_store" . $objS->new_id . "','1000','shop','G','W') ");
                    foreach ($language->_getLanguageList() as $key => $val) {

                        $db->Execute(
                            "INSERT IGNORE INTO " . TABLE_LANGUAGE_CONTENT . " (translated,  language_code, language_key, language_value, 	class)
                                VALUES ('1',?,'TEXT_CAT_STORE" . (int)$objS->new_id . "',?,'admin') ",
                            array($val['code'], $data['shop_domain'])
                        );

                        $title = $this->getBaseLangContent($val['code'], 'TEXT_PRODUCTS_NAME');
                        if ($title) {
                            $db->Execute(
                                "INSERT IGNORE INTO " . TABLE_LANGUAGE_CONTENT . " (translated,  language_code, language_key, language_value, 	class)
                                    VALUES ('1',?,'TEXT_PRODUCTS_NAME_STORE" . (int)$objS->new_id . "',?,'admin') ",
                                array($val['code'], $title)
                            );
                        }

                        $title = $this->getBaseLangContent($val['code'], 'TEXT_CONTENT_TITLE');
                        if ($title) {
                            $db->Execute(
                                "INSERT IGNORE INTO " . TABLE_LANGUAGE_CONTENT . " (translated,  language_code, language_key, language_value, 	class)
                                    VALUES ('1',?,'TEXT_CONTENT_TITLE_STORE" . (int)$objS->new_id . "',?,'admin') ",
                                array($val['code'], $title)
                            );
                        }
                    }

                    $this->copyTableValuesByShop(TABLE_CONFIGURATION_LANG_MULTI, $objS->new_id, 1, 'store_id', '', 'language_content_id');

                    ($plugin_code = $xtPlugin->PluginCode('class.multistore.php:_set')) ? eval ($plugin_code) : false;
                }
            }
        }

        if ($objS->success) {
            $obj->success = true;
        } else {
            $obj->success = false;
        }

        if ($this->url_data['new'] == 'true' && $this->url_data['save'] == 'true') {
            $obj->message = TEXT_STORE_CREATED;
        }

        return $obj;

    }

    /* getBaseLangContent
     *
     * Returning the content text based on language and key
     *
     * @param (string) ($lang) - language code
     * @param (string) ($key) - language key to search for
     * @return string (if content variable is found) or false ( if missing)
     */
    function getBaseLangContent($lang, $key)
    {
        global $db;

        $t = $db->Execute(
            "SELECT language_value FROM " . TABLE_LANGUAGE_CONTENT . " WHERE language_code=? and language_key=? and class='admin' LIMIT 0,1",
            array($lang, $key)
        );
        if ($t->RecordCount() > 0) {
            return $t->fields['language_value'];
        } else false;
    }

    function _unset($id = 0)
    {
        global $db, $xtPlugin;

        if (strstr($id, 'store_')) {
            $id = str_replace('store_', '', $id);
        }

        if ($id == 0 || $id == 1) return false;
        if ($this->position != 'admin') return false;
        $id = (int)$id;
        if (!is_int($id)) return false;

        $this->deletePermissions(TABLE_CONTENT_PERMISSION, $id);
        $this->deletePermissions(TABLE_PRODUCTS_PERMISSION, $id);
        $this->deletePermissions(TABLE_CATEGORIES_PERMISSION, $id);

        $this->deleteCustomer($id);
        $this->deleteOrder($id);

        $db->Execute("DROP TABLE IF EXISTS " . TABLE_CONFIGURATION_MULTI . $id);
        $db->Execute("DELETE FROM " . $this->_table . " WHERE " . $this->_master_key . " = ?", array($id));

        // delete from payment and plugin config
        $db->Execute("DELETE FROM " . TABLE_CONFIGURATION_PAYMENT . " WHERE shop_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_PLUGIN_CONFIGURATION . " WHERE shop_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_ADMIN_NAVIGATION . " WHERE text='cat_store" . $id . "'");
        $db->Execute("DELETE FROM " . TABLE_SEO_URL . " WHERE store_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_PRODUCTS_DESCRIPTION . " WHERE products_store_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_CONTENT_ELEMENTS . " WHERE content_store_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_MANUFACTURERS_DESCRIPTION . " WHERE manufacturers_store_id=?", array($id));
        $db->Execute("DELETE FROM " . TABLE_CATEGORIES_DESCRIPTION . " WHERE categories_store_id=?", array($id));

        $db->Execute("DELETE FROM " . TABLE_CONFIGURATION_LANG_MULTI . " WHERE store_id=?", array($id));

        ($plugin_code = $xtPlugin->PluginCode('class.multistore.php:_unset')) ? eval ($plugin_code) : false;
    }

    function _getParams()
    {
        $params = array();

        $header['shop_domain'] = array('type' => 'textfield');
        $header['shop_ssl_domain'] = array('type' => 'textfield');
        $header['shop_http'] = array('type' => 'textfield');
        $header['shop_https'] = array('type' => 'textfield');
        $header['virtual_folder'] = array('type' => 'textfield');
        $header['shop_id'] = array('type' => 'hidden');
        $header['admin_ssl'] = array('type' => 'status');

        $header['shop_ssl'] = array('type' => 'dropdown', 'url' => 'DropdownData.php?get=ssl_options');
        $groupingPosition = 'SHOP';
        $grouping['shop_domain'] = array('position' => $groupingPosition);
        $grouping['shop_ssl_domain'] = array('position' => $groupingPosition);
        $grouping['shop_http'] = array('position' => $groupingPosition);
        $grouping['shop_https'] = array('position' => $groupingPosition);
        $grouping['shop_id'] = array('position' => $groupingPosition);
        $grouping['shop_ssl'] = array('position' => $groupingPosition);
        $grouping['admin_ssl'] = array('position' => $groupingPosition);
        $grouping['shop_status'] = array('position' => $groupingPosition);
        $grouping['virtual_folder'] = array('position' => $groupingPosition);

        $params['header'] = $header;
        $params['grouping'] = $grouping;
        $params['master_key'] = 'shop_id';
        $params['default_sort'] = 'shop_id';

        return $params;
    }

    function setPosition($position)
    {
        $this->position = $position;
    }
}
