<?php
/*
 * #########################################################################
 * # xt:Commerce Shopsoftware
 * # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * #
 * # Copyright 2007-2018 xt:Commerce International Ltd. All Rights Reserved.
 * # This file may not be redistributed in whole or significant part.
 * # Content of this file is Protected By International Copyright Laws.
 * #
 * # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 * #
 * # http://www.xt-commerce.com
 * #
 * # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * #
 * # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 * #
 * # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * #
 * # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 * #
 * # office@xt-commerce.com
 * #
 * #########################################################################
 */

defined ( '_VALID_CALL' ) or die ( 'Direct Access is not allowed.' );

include_once _SRV_WEBROOT . 'xtFramework/library/phpxml/xml.php';

class themes {
	
	var $master_id = 'code';
	function setPosition($position) {
		$this->position = $position;
	}
	
	
	function _getParams() {
		global $language;
		
		$params = array ();
		
		$params ['header'] = array ();
		$params ['master_key'] = $this->master_id;
		$params ['default_sort'] = 'code';
		
		$params ['SortField'] = 'code';
		$params ['SortDir'] = 'ASC';
		
		if($this->url_data['pg']=='overview' && !$this->url_data['edit_id'] && $this->url_data['new'] != true){
			$params['include'] = array ('theme_preview_icon','title', 'theme_version', 'code');



            $rowActions[] = array('iconCls' => 'theme_history', 'qtipIndex' => 'qtip1', 'tooltip' => TEXT_THEME_HISTORY);
            if ($this->url_data['edit_id'])
                $js = "var edit_id = ".$this->url_data['edit_id']."; var edit_name = '".htmlentities($this->url_data['edit_id'])."';\n";
            else
                $js = "var edit_id = record.id; var edit_name=record.get('edit_id');\n";
            $js .= "addTab('adminHandler.php?load_section=themes_history&theme_dir='+edit_id,'".TEXT_THEME_HISTORY." ('+edit_id+')', 'theme_history'+edit_id)";

            $rowActionsFunctions['theme_history'] = $js;



			$rowActions[] = array('iconCls' => 'copy', 'qtipIndex' => 'qtip1', 'tooltip' => TEXT_THEME_COPY);
			if ($this->url_data['edit_id'])
				$js = "var edit_id = ".$this->url_data['edit_id'].";";
			else
				$js = "var edit_id = record.id;";
			$js.= "Ext.Msg.confirm('".TEXT_THEMES."','".TEXT_THEME_COPY_DIALOG."',function(btn){doThemeCopy(edit_id,btn);})";
			$rowActionsFunctions['copy'] = $js;
			
			$rowActions[] = array('iconCls' => 'generate_css', 'qtipIndex' => 'qtip1', 'tooltip' => TEXT_THEME_GENERATECSS);
			if ($this->url_data['edit_id'])
				$js = "var edit_id = ".$this->url_data['edit_id'].";";
			else
				$js = "var edit_id = record.id;";
			$js.= "Ext.Msg.confirm('".TEXT_THEMES."','".TEXT_THEME_GENERATECSS_DIALOG."',function(btn){doCssGeneration(edit_id,btn);})";
			$rowActionsFunctions['generate_css'] = $js;
			
			$extF = new ExtFunctions();
			
			$js = "function doThemeCopy(edit_id,btn){
	  		var edit_id = edit_id;
	  		if (btn == 'yes') {
	  		".$extF->_RemoteWindow("TEXT_COPY_THEME","TEXT_COPY_THEME","row_actions.php?type=copy_theme&theme='+edit_id+'", '', array(), 800, 600).' new_window.show();'."
			}
		};";
			
			$js .= "function doCssGeneration(edit_id,btn){
	  		var edit_id = edit_id;
	  		if (btn == 'yes') {
	  		".$extF->_RemoteWindow("TEXT_THEME_GENERATECSS","TEXT_THEME_GENERATECSS","row_actions.php?type=generate_css&theme='+edit_id+'", '', array(), 800, 600).' new_window.show();'."
			}
		};";
			
			$params['rowActionsJavascript'] = $js;
		
		}else{			
			// dynamic tabs ?
			$tab = $this->getLessConfig($this->url_data['edit_id'],true);
			foreach ($tab as $_group => $_fields) {
				foreach ($_fields as $_key => $_var) {
					$grouping[$_key]=array('position' => $_group,'text'=>$_group);
					$header[$_key]=array('text'=>'@'.$_key,'type'=>'textfield');
				}
			}			
			// edit			
			$params['exclude'] = array ('theme_preview_icon','plugin_code', 'configuration', 'file');
			$header['code']=array('type'=>'hidden');
			//$grouping['code']=array('position' => 'colors');
		}
		
		
		
		$params	['grouping']         = $grouping;
		$params['header']         = $header;
		$params ['display_searchPanel'] = false;
		$params ['display_newBtn'] = false;
		$params ['display_editBtn'] = true;
		$params ['display_deleteBtn'] = false;
		
		$params ['rowActions'] = $rowActions;
		$params ['rowActionsFunctions'] = $rowActionsFunctions;
		
		return $params;
	}
	
	function _get($pID = 0) {
		if ($this->position != 'admin')
			return false;
		
		if ($pID === 'new') {
			$obj = $this->_set ( array (), 'new' );
			$pID = $obj->new_id;
		}
		
		if ($pID) {
			$data = $this->getLessConfig ( $pID );
			$data[0]['code']=$pID;
		} else {
			$data = $this->getThemes ();
		}
				
		$obj = new stdClass;
		$obj->totalCount = count($data);
		
		if($obj->totalCount==0){	
			$data[] =  array('icon'=>'', 'title'=>'', 'version'=>'', 'code'=>'', 'type'=>'');
		}
		
		$obj->data = $data;
		return $obj;
	}
	
	function _set($data, $set_type='edit') {
		
		global $logHandler;
		
		if ($this->position != 'admin') return false;

		$obj = new stdClass;
		
		if (!isset($data['code'])) {
			$obj->failed = true;
			return $obj;
		}
		
		$theme = $this->getThemes($data['code']);

		// duplicate current file
		$theme_dir = _SRV_WEBROOT . 'templates/' . $data['code'];
		$less_variable_file = $theme_dir.'/'.$theme[0]['less_folder'].'/'.$theme[0]['less_variable_file'];
		
		if (is_file ( $less_variable_file )) {
	
			$file_content = file_get_contents($less_variable_file);

			$updatedContent='';
			
			// save backup
			if (!copy($less_variable_file, str_replace('.less', '-'.time().'.org', $less_variable_file))) {
				$log_data = array();
				$log_data['error'] = 'cannot create duplicate of less file';
				$logHandler->_addLog('error', 'themes', '', $log_data);
				
				$obj->success = false;
				return $obj;
			}

			foreach (preg_split("/(\r\n|\n|\r)/", $file_content) as $ln) {
				
				if ($ln[0] != "@") {
					$updatedContent.=$ln."\n";
					continue;
				}
				
				$bits = explode(":", $ln);
				$key = substr(trim($bits[0]), 1);
				$value = trim($bits[1]);
				
				if (substr($value,-1)==';') $value=substr($value,0,strlen($value)-1);
				
				// check if value is in save data
				if (isset($data[$key]) &&  $data[$key]!=$value) {
					$updatedContent.='@'.$key.': '.$data[$key].';'."\n";
				} else {
					$updatedContent.=$ln."\n";
				}
				
			}
			if (is_writable($less_variable_file)) {
				file_put_contents($less_variable_file, $updatedContent);
				$obj->success = true;
				return $obj;
			} else {
				
				$log_data = array();
				$log_data['error'] = 'less file '.$less_variable_file.' not writeable';
				$logHandler->_addLog('error', 'themes', '', $log_data);
				
				$obj->success = false;
				return $obj;
			}
			
			
			
			
		} else {
			//echo 'file not exists';
			$obj->failed = true;
			$obj->message='file not exists'.$less_variable_file;
			return $obj;
		}
		
		
	}
	

	/**
	 * load theme xml config file
	 * @param unknown $theme
	 * @param string $return_tabs
	 * @return Ambigous <multitype:, string>
	 */
	private function getLessConfig($theme,$return_tabs=false) {

		$file = _SRV_WEBROOT . 'templates/' . $theme . '/theme.xml';
		$theme_dir = _SRV_WEBROOT . 'templates/' . $theme;
		$tabs = array();
		if (is_file ( $file )) {
			$xml = $this->xmlToArray ( $file );

			// TODO validate XML file
            if (!isset($xml ['xtcommercetheme'] ['less_folder']) or
            !isset($xml ['xtcommercetheme'] ['less_file']) or
            !isset($xml ['xtcommercetheme'] ['less_variable_file']) or
            !isset($xml ['xtcommercetheme'] ['css_file'])) {
                die(TEXT_THEME_ERROR_NO_CONFIG_FILE);
            }


			if ($xml ['xtcommercetheme'] ['less_support']=='true') {
				$less_variable_file = $xml ['xtcommercetheme'] ['less_variable_file'];
				$less_variable_file = $theme_dir.'/'.$xml ['xtcommercetheme'] ['less_folder'].'/'.$less_variable_file;
				if (is_file ( $less_variable_file )) {
					
					$file_content = file_get_contents($less_variable_file);
					
					$cssVar[0] = [];
					$current_tab = '';
					foreach (preg_split("/(\r\n|\n|\r)/", $file_content) as $ln) {

						if ($ln[0] != "@") {
							if (substr($ln,0,3)=='//#') {
								$_ln = substr($ln,3,strlen($ln));
								$lnJson = json_decode($_ln);
								$current_tab = $lnJson->tab;
							}
							continue;
						}

						$bits = explode(":", $ln);
						$key = substr(trim($bits[0]), 1);
						$value = trim($bits[1]);
						if (substr($value,-1)==';') $value=substr($value,0,strlen($value)-1);

						$cssVar[0][$key] = $value;
						$tabs[$current_tab][$key]='';
					}

					if ($return_tabs==true) return $tabs;
					return $cssVar;
					
				} else {
					die(TEXT_THEME_ERROR_NO_CONFIG_FILE);
				}


			} else {
				die(TEXT_THEME_ERROR_NO_LESS_SUPPORT);
			}
			
		} else {
			die(TEXT_THEME_ERROR_NO_CONFIG_FILE);
		}
		
	}
	
	/**
	 * load themes from template directory
	 * @param string $theme_code
	 * @return Ambigous <multitype:multitype:NULL unknown string  , unknown>
	 */
	private function getThemes($theme_code = '') {
		global $db;
		
		$themes = array ();
		if ($dir = opendir ( _SRV_WEBROOT . 'templates/' )) {
			while ( ($f = readdir ( $dir )) !== false ) {
				if ((is_dir ( $f ) || ! stristr ( $f, "." )) && $f != "." && $f != "..") {
					if ($f != 'payment' && $f != '.svn' && $f != '__xtAdmin') {
						$dirs [] = $f;
					}
				}
			} // while
			closedir ( $dir );
		}
		$i = 0;
		

		
		if ($theme_code) {
			unset ( $dirs );
			$dirs [] = $theme_code;
		}

		foreach ( $dirs as $key => $val ) {
			$file = _SRV_WEBROOT . 'templates/' . $val . '/theme.xml';
			if (is_file ( $file )) {
				// $xml = file_get_contents($file);
				$xml = $this->xmlToArray ( $file );
				
				$icon = '';
				if ($xml ['xtcommercetheme'] ['icon'] != '') {
					$icon = '../templates/' . $val . '/' . $xml ['xtcommercetheme'] ['icon'];
				}
				$themes [$i] = array (
						'theme_preview_icon' => $icon,
						'title' => $xml ['xtcommercetheme'] ['title'],
						/*'url' => $xml ['xtcommercetheme'] ['url'],*/
						'code' => $val,
						'description' => $xml ['xtcommercetheme'] ['description'],
						'theme_version' => $xml ['xtcommercetheme'] ['version'],
                        'less_folder'=>$xml ['xtcommercetheme'] ['less_folder'],
						'less_variable_file'=>$xml ['xtcommercetheme'] ['less_file'],
						'less_variable_file'=>$xml ['xtcommercetheme'] ['less_variable_file']
				);
				$i ++;
			}
		}
				
		return $themes;
	}
	
	/**
	 * unserialize XML to Standard Array
	 *
	 * @param String $xml
	 * @return unknown
	 */
	private function xmlToArray($xml)
	{
	
		$xml = file_get_contents($xml);
		return XML_unserialize($xml);
	}
	
	/**
	 * duplicate template
	 */
	public function copyTheme($theme) {

		$param = '/[^a-zA-Z0-9_-]/';
		$theme = preg_replace($param, '', $theme);
		// check if theme directory exists
		$theme_path = _SRV_WEBROOT . 'templates/' . $theme;

		
		
		if (!is_dir($theme_path)) {
			echo '<p class="updateinfo">' . TEXT_ERROR_THEME_DONT_EXIST . '</p>';
			die;
		}
		
	//	include_once(_SRV_WEBROOT_ADMIN . 'page_includes.php');
		
		$fileOutput = $this->duplicateTheme($theme);
		echo '<div class="highlightbox">' . $fileOutput . '</div>';
		
	}

	public function restore_theme($theme,$restore_file) {


        $param = '/[^a-zA-Z0-9_-]/';
        $theme = preg_replace($param, '', $theme);
        // check if theme directory exists
        $theme_path = _SRV_WEBROOT . 'templates/' . $theme;

        if (!is_dir($theme_path)) {
            echo '<p class="updateinfo">' . TEXT_ERROR_THEME_DONT_EXIST . '</p>';
            die;
        }

        $theme_settings = $this->getThemes($theme);

        $theme_dir = _SRV_WEBROOT . 'templates/' . $theme;

        $less_variable_file = $theme_dir.'/'.$theme_settings[0]['less_folder'].'s/'.$theme_settings[0]['less_variable_file'];
        $less_restore_file = $theme_dir.'/'.$theme_settings[0]['less_folder'].'/'.$restore_file;

        if (file_exists($less_variable_file) && file_exists($less_restore_file)) {

            file_put_contents($less_variable_file,file_get_contents($less_restore_file));

            echo '<div class="alert alert-success" role="alert">'.TEXT_THEME_RESTORE_SUCCESS.'</div>';

        } else {
            echo '<div class="alert alert-warning" role="alert">'.TEXT_THEME_RESTORE_ERROR.'</div>';
        }


    }
	
	/**
	 * generate css from less file
	 */
	public function generateCss($theme) {


		$param = '/[^a-zA-Z0-9_-]/';
		$theme = preg_replace($param, '', $theme);
		// check if theme directory exists
		$theme_path = _SRV_WEBROOT . 'templates/' . $theme;
	
	
	
		if (!is_dir($theme_path)) {
			echo '<p class="updateinfo">' . TEXT_ERROR_THEME_DONT_EXIST . '</p>';
			die;
		}
	//	include_once(_SRV_WEBROOT_ADMIN . 'page_includes.php');

		
		$file = _SRV_WEBROOT . 'templates/' . $theme . '/theme.xml';
		$theme_dir = _SRV_WEBROOT . 'templates/' . $theme;

		if (is_file ( $file )) {
			$xml = $this->xmlToArray ( $file );

			if ($xml ['xtcommercetheme'] ['less_support']=='true') {
				$less_file = $xml ['xtcommercetheme'] ['less_file'];
				$less_file = $theme_dir.'/'.$xml ['xtcommercetheme'] ['less_folder'].'/'.$less_file;
				if (is_file ( $less_file )) {
					
					try {
						$parser = new Less_Parser();
						

						$parser->parseFile( $less_file);
						
						$directories = array();
						if ($xml ['xtcommercetheme'] ['less_import_directories']!='') {

							$_dir = explode(',',$xml ['xtcommercetheme'] ['less_import_directories']);
							foreach ($_dir as $key => $val) {
								$directories[$theme_dir.'/'.$val]='';
							}

							$parser->SetImportDirs( $directories );
							
						}
						
						$css = $parser->getCss();
						
						// write new css to file
						if (is_writable($theme_dir.'/'.$xml ['xtcommercetheme'] ['css_file'])) {
							file_put_contents($theme_dir.'/'.$xml ['xtcommercetheme'] ['css_file'], $css);
						}

                        echo '<div class="alert alert-success" role="alert">'.TEXT_THEME_GENERATECSS_SUCCESS.'</div>';
						
					} catch (Exception $e) {
						echo '<div class="alert alert-warning" role="alert">'.$e->getMessage().'</div>';
					}
					

				}
			}
		}
		

		
	

	
	}
	
	/**
	 * duplicate directory
	 * @param unknown $theme_directory
	 * @param string $verbose
	 * @return boolean|string
	 */
	private function duplicateTheme($theme_directory, $verbose = true)
    {
        if (!$theme_directory)
        {
            return false;
        }
		$id = 0;
        $themePath = _SRV_WEBROOT . 'templates/'.$theme_directory;

        do  {
        	$id++;
        	$newThemeFolder = $themePath.'_'.$id.'/';
        	
        } while(is_dir($newThemeFolder));
        
        if (!is_dir($newThemeFolder)) {
        	mkdir($newThemeFolder);
        	chmod($newThemeFolder, 0777);
        }
        
        $srcdir = $themePath;
        $dstdir = $newThemeFolder;
        
        $output = '<br /><b>Copy to: ' . $dstdir . '/</b><br />';
        $return = $this->dircopy($srcdir, $dstdir, true);
        $output .= '<div style="padding: 5px; border: 1px solid #777777; height: 100px; overflow:auto;">' . $return['output'] . '</div>';
        $output .= '<b>' . $return['count'] . ' files copied</b><br />';
        return $output;

    }
    
    /**
     * copy full directory including sub directory
     * @param unknown $srcdir
     * @param unknown $dstdir
     * @param string $verbose
     * @return multitype:Ambigous <string, unknown> Ambigous <number, string, unknown>
     */
    private function dircopy($srcdir, $dstdir, $verbose = false)
    {
    	$num = 0;
    	if (!is_dir($dstdir))
    	{
    		mkdir($dstdir);
    		chmod($dstdir, 0777);
    	}
    
    	$output = '';
    	if ($curdir = opendir($srcdir))
    	{
    		while ($file = readdir($curdir))
    		{
    			if ($file != '.' && $file != '..' && $file != '.svn' && $file != '.DS_Store')
    			{
    				$srcfile = $srcdir . '/' . $file;
    				$dstfile = $dstdir . '/' . $file;
    
    				if (is_file($srcfile))
    				{
    					if (is_file($dstfile))
    					{
    						$ow = filemtime($srcfile) - filemtime($dstfile);
    					}
    					else
    					{
    						$ow = 1;
    					}
    					if ($ow > 0)
    					{
    						if ($verbose)
    						{
    							$output .= "  Copying " . str_replace(_SRV_WEBROOT, '', $srcfile) . "...";
    						}
    						if (copy($srcfile, $dstfile))
    						{
    							touch($dstfile, filemtime($srcfile));
    							$num++;
    							if ($verbose)
    							{
    								$output .= "OK<br />";
    							}
    						}
    						else
    						{
    							$output .= "Error: File " . str_replace(_SRV_WEBROOT, '', $srcfile) . " could not be copied!<br />";
    						}
    					}
    				}
    				elseif (is_dir($srcfile))
    				{
    					$data = $this->dircopy($srcfile, $dstfile, $verbose);
    					$num += $data['count'];
    					$output .= $data['output'];
    				}
    			}
    		}
    		closedir($curdir);
    	}
    
    	return array('count' => $num, 'output' => $output);
    }
}